# Kompira リリースノート

---
## Ver.1.5.4 (2018/12/21)
### 新機能
- 外部連携
    -  リポジトリオブジェクトで mercurial に加えて git リポジトリと連携できるようになりました。
- REST API
    - 新しいインシデントを REST-API で作成できるようになりました。
        - /incident に対する POST アクセスでインシデントを作成できます。
- ライブラリ
    - [experimental] ライブラリオブジェクトの関数を JSON-RPC で呼び出すことができるようになりました。
        - ただし safe_source タイプのライブラリオブジェクトに限ります。
        - エンドポイントはライブラリオブジェクトのパス + .jsonrpc となります。
            - 例：/root/mylib というライブラリであれば /root/mylib.jsonrpc となります。
    - [experimental] ライブラリオブジェクトから別のライブラリオブジェクトの関数を呼び出せるようになりました。
        - 別ライブラリオブジェクトは、PEP-328 で規定される絶対インポートまたは相対インポートが可能です。
- 画面操作
    - インシデント一覧画面でインシデント状態ごとにフィルタリングできるようになりました。
    - インシデント一覧画面に表示できる列を増やしました。
    - インシデント一覧画面に検索機能を追加しました。
    - プロセス一覧画面に検索機能を追加しました。
    - 右上のユーザメニューに「ユーザ情報」と「パスワード変更」へのリンクを追加しました。

### 変更
- ユーザ管理
    - 特権ユーザは元のパスワードを入力せずにパスワードを変更できるようにしました。
- ライブラリ
    - ライブラリオブジェクトの内部的なモジュール名の命名方法を変更しました。
        - 旧：kompira.library. + ライブラリオブジェクトの名称
        - 新：kompira.library.objects + ライブラリオブジェクトのパス（/ は . に置換）
            - 例：/root/mylib というライブラリであれば kompira.library.objects.root.mylib となります。
    - ライブラリオブジェクト内部でのインポート方式を絶対インポートに変更しました。
        - 自動的に from __future__ import absolute_import が適用されます。
- インポート
    - オブジェクトのインポート時に更新日時を復元するようにしました。

### 修正
- issue #1138: リポジトリ連携で空テーブルや空ディレクトリが作成されない問題を修正しました。
- issue #1218: 特定の名称を持つライブラリオブジェクトを正常に呼び出せない問題を修正しました。
- issue #1242: dateオブジェクトのweekdayプロパティが正しい値を返さない問題を修正しました。
- issue #1241: datetimeオブジェクトのformat()メソッドが異常終了する問題を修正しました。
- issue #1248: REST API でスケジューラを登録するとき、日時週などに不正な値を指定してもエラーにならない問題を修正しました。
- issue #1250: セッションブロックでリモートから切断したときにジョブマネージャのセッションが終了しない場合がある問題を修正しました。
- issue #1255: チャネルの削除とメッセージの送受信を同時にすると、DBがデッドロックすることがある問題を修正しました。
- issue #1257: Windows へのファイル put で正常にファイル転送できない場合がある問題を修正しました。

---
## Ver.1.5.3 (2018/11/16)
### 新機能
- ジョブフロー
    - ジョブ/ライブラリ呼び出しの引数に対して、配列や辞書を *args や **kwargs のように展開して渡せるようになりました。
    - 日付および時刻を扱う Date 型と Time 型を追加しました。
        - date() 組み込み関数で、指定された文字列から日時データに変換できます。
        - time() 組み込み関数で、指定された文字列から時刻データに変換できます。
    - mailto() 組込みジョブに charset 引数を追加して送信時の文字コードを指定できるようになりました。
        - charset="iso-2022-jp" などと指定できます。
        - ただし python の仕様で shiftjis や eucjp を指定しても iso-2022-jp にエンコードされます（対応検討中）。
- データモデル
    - 日付および時刻を記録する Date フィールドと Time フィールドを追加しました。
- 外部連携
    -  メールチャネルで IMAP サーバへのログイン時に CRAM-MD5 認証に対応しました。
- 画面操作
    - リポジトリ連携でプッシュするときにコミットメッセージが入力できるようになりました。

### 変更
- issue #1237: kompirad ワーカプロセスのメモリ制限デフォルト値を 1GB から 4GB に変更しました。

### 修正
- issue #1239: [security] 認証を経由せずに Kompira API で GET アクセスできてしまうことがある問題を修正しました。
- issue #1220: メールチャネルで長すぎる行を含むメールのフェッチに失敗することがある問題を修正しました。
- issue #1163: メールボックスに大量にメールが存在する場合にメールチャネル(IMAP)で受信できないことがある問題を修正しました。
- issue #1105: mailto でメールを送信する際に本文に長すぎる行を含んでいると、メール配送中に改行が挿入され文字化けする場合がある問題を修正しました。

### その他
- CentOS6系でのテストの安定性を向上しました。

---
## Ver.1.5.2 (2018/10/30)

### 新機能
- ジョブフロー
    - 文字列型に format(), join(), find() などの、文字列操作用メソッドを追加しました。
    - 辞書型にキー一覧を取得する get_keys() メソッドを追加しました。
    - 浮動小数点を扱えるように float() 組み込み関数を追加しました。
    - datetime 型に ISO 文字列を取得する isoformat() メソッドを追加しました。
    - timedelta 型にトータルの経過秒数を取得する total_seconds プロパティを追加しました。
    - [experimental] ディレクトリ型にオブジェクトの検索ができる find() および glob() メソッドを追加しました。
- REST API
    - テーブルに対する .children API で以下のようにフィールド値による並び替えを指定できるようにしました。
        - order_by=field:<フィールド名>      (昇順)
        - order_by=-field:<フィールド名>     (降順)
    - REST-API のフィルタリングで、以下のようにフィールド値の絞込み／範囲指定をできるようにしました。
        - field:<フィールド名>=<値> 
        - field:<フィールド名>__<ルックアップ>=<値> 
- 画面操作
    - テーブル編集画面に「表示フィールドの追加」メニューを追加しました。
    - プロセス一覧画面で「正常終了したプロセス」「異常終了したプロセス」をフィルタリングできるようにしました。
    - ディレクトリや検索ビューの画面遷移でページサイズとソート順を保持するようにしました。

### 変更
- ディレクトリ一覧画面などでの日時表記フォーマットを YYYY/MM/DD hh:mm::ss 形式に変更しました。
- 一覧画面で選択可能な表示件数を 1000 まで拡張しました。


### 修正
- issue #1222: ファイル名にNFDエンコードされた濁点を含む場合にディレクトリインポートに失敗する問題を修正しました。
- issue #1225: オブジェクト選択フィールドでページ送りが出来ない問題を修正（暫定対処）しました。
- issue #1227: sendevt モードでのインストール時に失敗することがある問題を修正しました。
- issue #1228: CentOS6 系でのテストに失敗することがある問題を改善しました。

### その他
- ディレクトリ一覧画面やプロセス一覧画面において表示パフォーマンスを改善しました。
- javascript ライブラリをアップデートしました。
    - js.cookie (2.2.0) [New]
    - Moment (2.22.2) [New]
    - JsRender (0.9.91)

---
## Ver.1.5.1 (2018/09/14)

### 新機能
-  英語対応および英語版ドキュメントを添付しました。
    - インストール時の言語設定によって日本語または英語設定になります。
    - インストール時に --locale-lang オプションで言語を指定可能です（システムの言語設定を変更します）。
    - デフォルトではシステムの言語設定を変更しません（【非互換】以前のバージョンでは日本語に変更していました）。
    - 日本語(ja_JP.UTF-8)および英語(en_US.UTF-8)でのみ動作確認しています。
- 型オブジェクトの編集画面で、フィールド修飾子をポップアップダイアログで編集できるようになりました。
- フィールド修飾子に指定できる項目を追加しました。
    - Array/Dictionary型: default でデフォルト値が指定できるようになりました。
    - String型: max_length で最大長を指定できます。
    - String型: pattern で入力可能な文字列パターンを正規表現で指定できます。
    - Integer型: min_value/max_value で最小値／最大値を指定できます。
    - File型: file_accept でファイル選択ダイアログで表示するファイル種別を指定できます。
- 配列・辞書フィールドの順序入れ替えが簡単にできるようになりました。
    - ドラッグアンドドロップによる順序入れ替え、CTRL + 上下カーソルキーによる入れ替えができます。
- インシデントをWeb画面から新規作成できるようになりました。
- ジョブフローからプロセスの監視モードを monitoring_mode で読み書きできるようになりました。

### 変更
- mailto() の Date ヘッダをローカルタイムになるようにしました。
- REST API で API キーによる認証を cookie より優先するようになりました。
- manage.py export_dir コマンドによるエクスポート時に権限情報を出力できるようになりました。

### 修正 
- issue #1004: forkプロセス、スケジューラやAPIから起動したジョブフローでも、監視モードに応じてメール通知されるように修正しました。
- issue #1031: mailto() で日本語添付ファイル名の扱いを修正しました。
- issue #1208: 長すぎるフィールド修飾子を指定したオブジェクトの作成でエラーになる問題を修正しました。
- issue #1215: 多重度設定したジョブフローの並列実行が終了しない問題を修正しました。
- issue #1216: $RESULTや$ERRORに日本語を含むプロセスオブジェクトをmanage.py dumpdataできない問題を修正しました。

### その他
- pythonライブラリをアップデートしました
    - mod_wsgi (4.5.24 → 4.6.4)
    - psycopg2 (2.6.2) → psycopg2_binary (2.7.5)
    - psutil (5.4.6) [New]
- javascript ライブラリをアップデートしました。
    - jquery-ui (1.12.1) [New]

---
## Ver.1.5.0 (2018/07/05)

### プラットフォームの移行

#### Python2.7 対応

- Python 2.7 系に対応し、Python 2.6 系は非対応となりました。
- Python 2.7 がインストールされていない環境では、インストーラが自動的に Python 2.7 をインストールします。

ジョブフローから実行する python スクリプトなども 2.7 系で実行されることになるため、バージョンに依存するスクリプトを利用する場合は注意してください。

#### CentOS 7 / RHEL 7 対応

- CentOS 7 および RHEL 7 にインストールできるようになりました。
- CentOS 6 および RHEL 6 にも引き続きインストール可能です。

#### ミドルウェアのアップデート

Kompira が利用するミドルウェアをアップデートしました。アップデートした主要なミドルウェアを以下に示します。

- データベース
    - PostgreSQL 9.6
- Python ライブラリ
    - django 1.8.19
    - djangorestframework 3.2.5
    - Django-Select2 4.3.2
    - pywinrm 0.3.0
    - Jinja2 2.10
    - python-daemon 2.1.2
- JavaScript ライブラリ
    - jquery 1.12.4

#### バグ修正

- Kompira オブジェクトのフィールド値書き込み時に、DB 排他制御が不足している場合がある問題を修正しました。
- ジョブフローからメールチャネルを読み込んでも、メールサーバへのポーリングが開始しない場合がある問題を修正しました。

その他の修正については、ChangeLog をご参照ください。

---
## 更新方法

Ver.1.5.0 から、インストーラは標準ではデータを保持してアップデートを試行
するになりました。オプションを付けずに install.sh を実行してください。

    ./install.sh

なお、この変更に伴い --update オプションは廃止になりました。

データ移行のためインストーラがバックアップを作成しますが、データ移行が
不要な場合は --no-backup オプションを付与することで、バックアップを作成
せず更新に必要なディスク容量を削減できます。

    ./install.sh --no-backup

データベースを明示的に初期化する場合は --initdata オプションを付与して
インストーラを実行してください。

    ./install.sh --initdata

なお、1.5.0 より前のデータは移行できません。一度、manage.py の export_data
コマンドを用いてデータをエクスポートした後、Kompira 1.5.0 をインストールし、
import_data コマンドにてインポートしなおしてください。

継続での利用にはライセンスファイルを登録する必要がございますので、ご注
意ください。ライセンスファイルはライセンス申請を行うことで取得可能です。
